SystemOrganization addCategory: #'Magritte-ComponentDecoration'!

!MADescriptionComponent class methodsFor: '*magritte-componentdecoration-override' stamp: 'kph 12/8/2007 22:49'!
memento: aMemento description: aDescription parent: aComponent
	^ self new
		setMemento: aMemento;
		setDescription: aDescription;
		setParent: aComponent;
		addDecorationClasses: aDescription decorationClasses;
		yourself! !

!MADescriptionComponent methodsFor: '*magritte-componentdecoration' stamp: 'kph 8/11/2007 19:41'!
addDecorationClasses: classes
 
	classes do: [ :c | c new addTo: self  ]! !

!MAContainer methodsFor: '*magritte-componentdecoration' stamp: 'kph 8/14/2007 02:21'!
atLabel: aLabel
	^ self detect: [ :desc | desc label = aLabel ]! !

MAComponentDecoration subclass: #MAAnnotationDecoration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-ComponentDecoration'!

!MAAnnotationDecoration methodsFor: 'as yet unclassified' stamp: 'kph 8/11/2007 19:24'!
postAnnotation

	^ self component description propertyAt: #postAnnotation ifAbsent: nil! !

!MAAnnotationDecoration methodsFor: 'as yet unclassified' stamp: 'kph 8/11/2007 19:25'!
preAnnotation

	^ self component description propertyAt: #preAnnotation ifAbsent: nil! !

!MAAnnotationDecoration methodsFor: 'as yet unclassified' stamp: 'kph 9/22/2008 02:01'!
renderContentOn: html 

		   self 
				renderPreAnnotation: self preAnnotation on: html;				
			   	renderOwnerOn: html;
			 	renderPostAnnotation: self postAnnotation on: html ! !

!MAAnnotationDecoration methodsFor: 'as yet unclassified' stamp: 'kph 9/22/2008 02:01'!
renderPostAnnotation: text on: html

	text ifNotNil: [ html html: text ]! !

!MAAnnotationDecoration methodsFor: 'as yet unclassified' stamp: 'kph 9/22/2008 02:01'!
renderPreAnnotation: text on: html

	text ifNotNil: [ html html: text ]! !

MAAnnotationDecoration subclass: #PRAnnotationDecoration
	instanceVariableNames: 'pre post'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-ComponentDecoration'!

!PRAnnotationDecoration methodsFor: 'as yet unclassified' stamp: 'kph 9/22/2008 02:12'!
children

	^ Array streamContents: [ :str |
	
		pre ifNotNil: [ str nextPutAll: (self context componentsOf: pre) ].
		post ifNotNil: [ str nextPutAll: (self context componentsOf: post) ].
	
	]! !

!PRAnnotationDecoration methodsFor: 'as yet unclassified' stamp: 'kph 9/22/2008 01:33'!
context

	^ PRCurrentContext value
  ! !

!PRAnnotationDecoration methodsFor: 'as yet unclassified' stamp: 'kph 9/22/2008 02:03'!
pageFrom: wikiText
  
	| page |
	page := PRPage new contents: wikiText.
	page document ifNotNilDo: [ :d | d owner: self context structure ].

	^ page
	
! !

!PRAnnotationDecoration methodsFor: 'as yet unclassified' stamp: 'kph 9/22/2008 01:57'!
processChildCallbacks: aStream
 	super processChildCallbacks: aStream.
 
	self children do: [:ea | ea processCallbackStream: aStream]! !

!PRAnnotationDecoration methodsFor: 'as yet unclassified' stamp: 'kph 9/22/2008 02:02'!
renderPostAnnotation: text on: html

	text isEmptyOrNil ifTrue: [ ^nil ].
	
	self context renderer
		continue: (post ifNil: [ post := self pageFrom: text])
		in: self
		on: html;
		yourself! !

!PRAnnotationDecoration methodsFor: 'as yet unclassified' stamp: 'kph 9/22/2008 02:02'!
renderPreAnnotation: text on: html

	text isEmptyOrNil ifTrue: [ ^nil ].
	
	self context renderer
		continue: (pre ifNil: [ pre := self pageFrom: text])
		in: self
		on: html;
		yourself! !

!MAComponentDecoration methodsFor: '*magritte-componentdecoration' stamp: 'kph 8/11/2007 20:24'!
addTo: component

	component addDecoration: self.
	
	^ component! !

!MADescription class methodsFor: '*magritte-componentdecoration' stamp: 'kph 8/11/2007 14:21'!
defaultDecorationClasses

	^ #()! !

!MADescription methodsFor: '*magritte-componentdecoration' stamp: 'kph 8/11/2007 14:20'!
decorationClasses
	^ self propertyAt: #decorationClasses ifAbsent: [ self class defaultDecorationClasses ]! !

!MADescription methodsFor: '*magritte-componentdecoration' stamp: 'kph 8/11/2007 14:46'!
decorationClasses: aClass
	^ self propertyAt: #decorationClasses put: aClass! !
